﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PhotoGallery1
{
	public partial class ImageFolder : UserControl
	{
		public string ImageSource { get; set; }

		private string _relativePath;
		public string RelativePath 
		{
			get
			{
				return _relativePath;
			}
			set
			{
				_relativePath = value;
				string[] parts = _relativePath.Split('/');
				string folderName = null;
				int i=parts.Length - 1;
				while (string.IsNullOrEmpty(folderName) && i >= 0)
				{
					folderName = parts[i--];
				}
				if (string.IsNullOrEmpty(folderName))
				{
					FolderName.Text = "";
				}
				else
				{
					FolderName.Text = folderName;
				}
			}
		}

		private bool _selected = false;

		public ImageFolder()
		{
			InitializeComponent();
		}

		public ImageFolder(string imageSource)
		{
			InitializeComponent();

			Uri uri = new Uri(imageSource, UriKind.RelativeOrAbsolute);
			ImageSource img = new System.Windows.Media.Imaging.BitmapImage(uri);
			Image1.SetValue(Image.SourceProperty, img);

			ImageSource = imageSource;
		}

		public void Select()
		{
			_selected = true;

			GrowAnim.Begin();
		}

		public void DeSelect()
		{
			_selected = false;

			ShrinkAnim.Begin();
		}

		private void Image1_MouseEnter(object sender, MouseEventArgs e)
		{
			GrowAnim.Begin();
		}

		private void Image1_MouseLeave(object sender, MouseEventArgs e)
		{
			if (!_selected)
			{
				ShrinkAnim.Begin();
			}
		}
	}
}
