﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PhotoGallery1
{
	public partial class Thumbnail : UserControl
	{
		public string ImageSource { get; set; }
		public string RelativePath { get; set; }
		public int Rotation { get; set; }
		public string Privacy { get; set; }
		public bool IsSelected { get; set; }

		public Thumbnail()
		{
			InitializeComponent();
		}

		public Thumbnail(string imageSource)
		{
			InitializeComponent();

			Uri uri = new Uri(imageSource, UriKind.RelativeOrAbsolute);
			ImageSource img = new System.Windows.Media.Imaging.BitmapImage(uri);
			Image1.SetValue(Image.SourceProperty, img);

			ImageSource = imageSource;
			IsSelected = false;
		}

		public void Select()
		{
			IsSelected = true;

			GrowAnim.Begin();
		}

		public void DeSelect()
		{
			IsSelected = false;

			ShrinkAnim.Begin();
		}

		private void Image1_MouseEnter(object sender, MouseEventArgs e)
		{
			GrowAnim.Begin();
		}

		private void Image1_MouseLeave(object sender, MouseEventArgs e)
		{
			if (!IsSelected)
			{
				ShrinkAnim.Begin();
			}
		}
	}
}
