﻿<%@ Application Language="C#" %>

<script runat="server">

    void Application_Start(object sender, EventArgs e) 
    {
        // Code that runs on application startup
		//
		
		// Init logging first.
		//
		string logFolder = HttpContext.Current.Server.MapPath("App_Data\\Logs\\");
		string appName = "Photo Gallery";
		Rlc.Utilities.Logging.Logger.AddRollingFileLogger(logFolder, appName);
		Rlc.Utilities.Logging.Logger.LogStatus("Application", "Start");
		
		// Inform the user manager where the user data
		//	is located.
		//
		string userXmlPath = Server.MapPath("App_Data");
		userXmlPath = System.IO.Path.Combine(userXmlPath, "users.xml");
		Rlc.PhotoGallery.Bll.UserManager.UserXmlFilePath = userXmlPath;
    }
    
    void Application_End(object sender, EventArgs e) 
    {
        //  Code that runs on application shutdown
		Rlc.Utilities.Logging.Logger.LogWarning("Application", "End");
    }
        
    void Application_Error(object sender, EventArgs e) 
    { 
        // Code that runs when an unhandled error occurs
		Exception ex = Server.GetLastError();
		Rlc.Utilities.Logging.Logger.LogError("Application", "Exception: " + Environment.NewLine + ex.ToString());
    }

    void Session_Start(object sender, EventArgs e) 
    {
        // Code that runs when a new session is started
		
		// Get this user's IP address and log
		//
		string ipAddress = Request.ServerVariables["REMOTE_ADDR"];
		Rlc.Utilities.Web.IpLocator.Location location = Rlc.Utilities.Web.IpLocator.Find(ipAddress);
		Rlc.Utilities.Logging.Logger.LogStatus("Session", "Entered Site: " + location);
    }

    void Session_End(object sender, EventArgs e) 
    {
        // Code that runs when a session ends. 
        // Note: The Session_End event is raised only when the sessionstate mode
        // is set to InProc in the Web.config file. If session mode is set to StateServer 
        // or SQLServer, the event is not raised.

    }
       
</script>
