﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using Rlc.PhotoGallery.Bll;

public partial class MyImageFrame : System.Web.UI.UserControl
{
	public GalleryObject Item;

	private string PageBaseUrl
	{
		get
		{
			string pageUrl = Page.Request.Url.OriginalString;
			if (pageUrl.IndexOf("?") != -1)
			{
				pageUrl = pageUrl.Split('?')[0];
			}
			return pageUrl;
		}
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		if (Item != null)
		{
			SetImage(Item);
		}
	}

	public void SetImage(GalleryObject item)
	{
		// Set the image.
		//
		_image.Src = GetThumbNailUrl(item, ConfigData.RootThumbDirectory, ConfigData.RootGalleryDirectory);
		_image.Alt = item.Info.Title;


		if (item.GalleryObjectType == GalleryObject.GalleryObjectTypeOptions.Image)
		{
			// Invoke the javascript call to show the high
			//	resolution image.
			//
			_link.Title = item.Info.Title;
		}
		else
		{
			// Need to link up the navigate to a deeper folder
			//	mechnism here.
			//
			string relativePath = item.FullPath.Replace(ConfigData.RootGalleryDirectory, "");
			_link.HRef = relativePath;

			string[] folders = relativePath.Split('\\');
			_link.Title = folders[folders.Length - 1];

			// Use a special class to allow jquery selection
			//
			_imageFrame.Attributes.Add("class", "folderFrame");
		}
	}

	/// <summary>
	/// Gets the thumb nail URL.
	/// </summary>
	/// <param name="obj">The obj.</param>
	/// <param name="thumbRootFolder">The thumb root folder.</param>
	/// <param name="photoRootFolder">The photo root folder.</param>
	/// <returns></returns>
	private static string GetThumbNailUrl(GalleryObject obj, string thumbRootFolder, string photoRootFolder)
	{
		string thumbNailFullPath = GalleryManager.GetThumbNailImageFullPath(obj, thumbRootFolder, photoRootFolder);
		string thumbNailRelativePath = thumbNailFullPath.Replace(thumbRootFolder, "");
		string rotation = string.Empty;
		if (obj.Info.Rotation != PhotoInfo.RotateOptions.None)
		{
			rotation = "&r=" + (int)obj.Info.Rotation;
		}
		thumbNailRelativePath = "Image.ashx?rp=" + thumbNailRelativePath + "&t=1" + rotation;

		return thumbNailRelativePath;
	}
}
