﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using Rlc.Utilities.Logging;
using System.Collections.Generic;
using Rlc.PhotoGallery.Bll;

public partial class Logs : System.Web.UI.Page
{
	private bool IsAdmin
	{
		get
		{
			bool isAdmin = false;
			UserInfo userInfo = CurrentUser;
			if (userInfo != null && userInfo.UserType == UserInfo.TypeOptions.Admin)
			{
				isAdmin = true;
			}
			else
			{
				Logger.LogWarning("Security", "Attempted to access admin features without admin rights!");
			}
			return isAdmin;
		}
	}
	private UserInfo CurrentUser
	{
		get
		{
			if (HttpContext.Current.Session["user"] != null)
			{
				return (UserInfo)HttpContext.Current.Session["user"];
			}
			return null;
		}
	}

	private void BindList()
	{
		string logFolder = HttpContext.Current.Server.MapPath("App_Data\\Logs\\");
		List<LogEntry> list = Logger.ParseFilesInFolder(logFolder);

		lvLogs.DataSource = list;
		lvLogs.DataBind();
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		if (IsAdmin)
		{
			BindList();
		}
	}
}
